#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

const long MAXN = 15;

long a[5];
long count[5];
long box[MAXN];
double e[MAXN][5];
long cGuests;
double d[5];

void BackTrack(long k, double ver)
{
	long i;
	if (k == cGuests)
		d[box] += ver;
	else
	{
        for (i = 0; i < 5; ++i)
		{
			if (count[i] < a[i])
			{
				++count[i];
				if (!k)
					box = i;
				BackTrack(k+1, ver*e[k][i]);
				--count[i];
			}

		}
	}
}

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long cCases, iCase;
	long i, j;
	double sumD;
	long maxBox;

	scanf("%ld", &cCases);

	for (iCase = 0; iCase < cCases; ++iCase)
	{
		scanf("%ld", &cGuests);
		
		for (i = 0; i < 5; ++i)
		{
			scanf("%ld", &a[i]);
			d[i] = 0;
		}

		for (i = 0; i < cGuests; ++i)
			for (j = 0; j < 5; ++j)
				scanf("%lf", &e[i][j]);
		memset(count, 0, sizeof(count));
		
		BackTrack(0, 1.0);

		sumD = 0;
		for (i = 0; i < 5; ++i)
			sumD += d[i];

		i = 0;
		while (a[i] == 0)
			++i;
		maxBox = i;


		for (i = 0; i < 5; ++i)
		{
			if (d[i] * a[maxBox] > d[maxBox] * a[i]  + 1e-12)
				maxBox = i;
		}

		printf("%ld %.3lf\n", maxBox+1, d[maxBox]/(sumD*a[maxBox]));



	}

#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}